{
  Autor   : Michael Springwald

  Datum   : Montag, 13.Augst.2007

  Updatet : Freitag, 17.Augst.2007, Samstag, 18.Augst.2007
            Mittwoch, 27.Febura.2008, Donnerstag, 06.März.2008
}

unit uPlutoCompo;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,StdCtrls,LResources,ucolorlist,Forms,Graphics,ExtCtrls,Controls,Buttons,LCLProc,LMessages;

type

  { TPlColorFehld }
  TPlColorFehld = class(TPanel)
  private
    FScrollBox:TScrollBox;
    fSelColor: TColor;
    oldClick:TShape;
    procedure SetSelColor(const AValue: TColor);
    procedure Click(Sender:TObject);

   protected
    procedure Paint; override;
    procedure Resize; override;
  public
    constructor Create(TheOwner: TComponent); override;
    destructor Destroy;
  published
    property SelectColor:TColor read fSelColor write SetSelColor;

  end;
  { TPlColorListBox }

  TPlColorListBox = class(TListBox)
  private
    fSelColor: TColor;
  protected
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X,
                      Y: Integer); override;

  public
    property SelColor:TColor read fSelColor write fSelColor;
    procedure DrawItem(Index: Integer; ARect: TRect; State: TOwnerDrawState
                     ); override;
                     
    constructor Create(TheOwner: TComponent); override;
    destructor Destroy; override;
  published

  end;



  { TPLFontListBox }

  TPLFontListBox = class(TListBox)
  private
    fDItem: Boolean;

  protected

  public
    property dItem:Boolean read fDItem write fdItem;

    procedure DrawItem(Index: Integer; ARect: TRect; State: TOwnerDrawState
                     ); override;
    constructor Create(TheOwner: TComponent); override;
    destructor Destroy; override;
  published

  end;
  
  { TPLColorComboBox }

  TPLColorComboBox = class(TComboBox)
  private
    fSelColor: TColor;
  protected
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X,
                      Y: Integer); override;
  public
    property SelColor:TColor read fSelColor write fSelColor;
    procedure DrawItem(Index: Integer; ARect: TRect; State: TOwnerDrawState
                     ); override;

    constructor Create(TheOwner: TComponent); override;
    destructor Destroy; override;
  published

  end;
  
  { TPLFontComboBox }

  TPLFontComboBox = class(TComboBox)
  private

  protected

  public
    fDItem: Boolean;

    property dItem:Boolean read fDItem write fdItem;

    procedure DrawItem(Index: Integer; ARect: TRect; State: TOwnerDrawState
                     ); override;

    constructor Create(TheOwner: TComponent); override;
    destructor Destroy; override;
  published

  end;
  
  { TPLBrushStyleListBOx }

  TPLBrushStyleListBox = class(TListBox)
  private
    fBrushStyle: TBrushStyle;
  protected
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X,
                      Y: Integer); override;

  public
    property SelBrushStyle:TBrushStyle read fBrushStyle write fbrushStyle;
    procedure DrawItem(Index: Integer; ARect: TRect; State: TOwnerDrawState
                     ); override;

    constructor Create(TheOwner: TComponent); override;
    destructor Destroy; override;

  published


  end;

  { TPLBrushStyleComboBox }

  TPLBrushStyleComboBox = class(TComboBox)
  private
    fBrushStyle: TBrushStyle;
  protected
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X,
                      Y: Integer); override;

  public
    property SelBrushStyle:TBrushStyle read fBrushStyle write fbrushStyle;
    procedure DrawItem(Index: Integer; ARect: TRect; State: TOwnerDrawState
                     ); override;

    constructor Create(TheOwner: TComponent); override;
    destructor Destroy; override;

  published

  end;
  

  { TPLPenStyleListBox }

  TPLPenStyleListBox = class(TListbox)
  private
    fPenStyle: TPenStyle;
  protected
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X,
                      Y: Integer); override;

  public
    property SelPenStyle:TPenStyle read fPenStyle write fPenStyle;
    procedure DrawItem(Index: Integer; ARect: TRect; State: TOwnerDrawState
                     ); override;

    constructor Create(TheOwner: TComponent); override;
    destructor Destroy; override;

  published

 end;

  { TPLPenStyleComboBox }

  TPLPenStyleComboBox = class(TComboBox)
  private
    fPenStyle: TPenStyle;
  protected
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X,
                      Y: Integer); override;

  public
    property SelPenStyle:TPenStyle read fPenStyle write fPenStyle;
    procedure DrawItem(Index: Integer; ARect: TRect; State: TOwnerDrawState
                     ); override;

    constructor Create(TheOwner: TComponent); override;
    destructor Destroy; override;

  published

 end;

 { TPLPaintBox }
 TPLPaintBox = class(TCustomControl)
 private

 protected
   procedure Paint; override;

 public
   constructor Create(TheOwner: TComponent); override;
   destructor Destroy; override;
 published
   property OnKeyDown;
   property OnKeyUp;
   property OnKeyPress;
   property OnMouseDown;
   property OnMouseMove;
   property OnMouseUp;
   property OnPaint;
 end; // TPLPaintBox
 
 procedure register;

implementation

procedure StrToPen(const aValue:String; var PenStyle:TPenStyle);
begin
  case StrToint(aValue) of
    0:PenStyle:=psSolid;
    1:PenStyle:=psDash;
    2:PenStyle:=psDot;
    3:PenStyle:=psDashDot;
    4:PenStyle:=psDashDotDot;
    7:PenStyle:=psClear;
  end;
end;

procedure StrToBrush(const aValue:String; var BrushStyle:TBrushStyle);
begin
  case StrToint(aValue) of
    0:BrushStyle:=bsSolid;
    1:BrushStyle:=bsClear;
    2:BrushStyle:=bsHorizontal;
    3:BrushStyle:=bsVertical;
    4:BrushStyle:=bsFDiagonal;
    5:BrushStyle:=bsBDiagonal;
    6:BrushStyle:=bsDiagCross;
    7:BrushStyle:=bsBDiagonal;
  end;
end;

procedure register;
begin
   RegisterComponents('Pluto',[TPLBrushStyleComboBox]);
   RegisterComponents('Pluto',[TPLBrushStyleListBox]);

   RegisterComponents('Pluto',[TPLColorComboBox]);
   RegisterComponents('Pluto',[TPlColorListBox]);
   RegisterComponents('Pluto',[TPlColorFehld]);

   RegisterComponents('Pluto',[TPLFontComboBox]);
   RegisterComponents('Pluto',[TPLFontListBox]);

   RegisterComponents('Pluto',[TPLPenStyleComboBox]);
   RegisterComponents('Pluto',[TPLPenStyleListBox]);
   RegisterComponents('Pluto',[TPLPaintBox]);

end; // procedure register

{ TPlColorListBox }

procedure TPlColorListBox.MouseDown(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
begin
  inherited MouseDown(Button, Shift, X, Y);
  if ItemIndex > -1 then
    SelColor:=String2ToColor(items[itemindex])
end;

procedure TPlColorListBox.DrawItem(Index: Integer; ARect: TRect;
  State: TOwnerDrawState);
begin
  canvas.FillRect(arect);

  canvas.Brush.color:=String2ToColor(Items[index]);
  canvas.FillRect(0,0,20,20);

  canvas.TextOut(20,arect.top,Items[index]);
end;

constructor TPlColorListBox.Create(TheOwner: TComponent);
begin
  inherited Create(TheOwner);
  Style:=lbOwnerDrawVariable;
  ColorToStringList(Items);
end;

destructor TPlColorListBox.Destroy;
begin
  inherited Destroy;
end;

{ TPLFontListBox }

procedure TPLFontListBox.DrawItem(Index: Integer; ARect: TRect;
  State: TOwnerDrawState);
begin
  canvas.FillRect(arect);

  if dItem then canvas.Font.Name:=Items[index];
  canvas.TextOut(0,arect.top,Items[index]);
end;

constructor TPLFontListBox.Create(TheOwner: TComponent);
begin
  inherited Create(TheOwner);
  Style:=lbOwnerDrawVariable;
  items:=Screen.Fonts;
  dItem:=True;
end;

destructor TPLFontListBox.Destroy;
begin
  inherited Destroy;
end;

{ TPLColorComboBox }

procedure TPLColorComboBox.MouseDown(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
begin
  if ItemIndex > -1 then
    SelColor:=String2ToColor(items[itemindex]);

  inherited MouseDown(Button, Shift, X, Y);
end;

procedure TPLColorComboBox.DrawItem(Index: Integer; ARect: TRect;
  State: TOwnerDrawState);
begin
  canvas.FillRect(arect);
  canvas.Brush.color:=String2ToColor(Items[index]);
  canvas.FillRect(0,0,20,20);
  canvas.TextOut(22,arect.top,Items[index]);
end;

constructor TPLColorComboBox.Create(TheOwner: TComponent);
begin
  inherited Create(TheOwner);
  Style:=csOwnerDrawVariable;
  ColorToStringList(Items);

end;

destructor TPLColorComboBox.Destroy;
begin
  inherited Destroy;

end;

{ TPLFontComboBox }

procedure TPLFontComboBox.DrawItem(Index: Integer; ARect: TRect;
  State: TOwnerDrawState);
begin
  canvas.FillRect(arect);
  if dItem then canvas.Font.Name:=Items[index];
  canvas.TextOut(0,arect.top,Items[index]);
end;

constructor TPLFontComboBox.Create(TheOwner: TComponent);
begin
  inherited Create(TheOwner);
  Style:=csOwnerDrawVariable;
  items:=Screen.Fonts;
end;

destructor TPLFontComboBox.Destroy;
begin
  inherited Destroy;
end;

{ TPLBrushStyleListBOx }

procedure TPLBrushStyleListBox.MouseDown(Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  inherited MouseDown(Button, Shift, X, Y);
  if Itemindex > -1 then
end;

procedure TPLBrushStyleListBox.DrawItem(Index: Integer; ARect: TRect;
  State: TOwnerDrawState);
begin
  canvas.FillRect(arect);

  StrToBrush(items[index],fBrushStyle);
  canvas.Brush.Style:=fBrushStyle;

  canvas.Brush.Color:=clBlack;
  canvas.Pen.Color:=clBlack;
  canvas.FillRect(arect);
end;

constructor TPLBrushStyleListBox.Create(TheOwner: TComponent);
begin
  inherited Create(TheOwner);
  Style:=lbOwnerDrawVariable;
  Items.Add('0');
  Items.Add('1');
  Items.Add('2');
  Items.Add('3');
  Items.Add('4');
  Items.Add('5');
  Items.Add('7');
  Items.Add('8');
end;

destructor TPLBrushStyleListBox.Destroy;
begin
  inherited Destroy;
end;

{ TPLBrushStyleComboBox }

procedure TPLBrushStyleComboBox.MouseDown(Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  inherited MouseDown(Button, Shift, X, Y);
end;

procedure TPLBrushStyleComboBox.DrawItem(Index: Integer; ARect: TRect;
  State: TOwnerDrawState);
begin
  inherited DrawItem(Index, ARect, State);

  canvas.FillRect(arect);

  StrToBrush(items[index],fBrushStyle);
  canvas.Brush.Style:=fBrushStyle;

  canvas.Brush.Color:=clBlack;
  canvas.Pen.Color:=clBlack;
  canvas.FillRect(arect);
end;

constructor TPLBrushStyleComboBox.Create(TheOwner: TComponent);
begin
  inherited Create(TheOwner);
  Style:=csOwnerDrawVariable;
  Items.Add('0');
  Items.Add('1');
  Items.Add('2');
  Items.Add('3');
  Items.Add('4');
  Items.Add('5');
  Items.Add('7');
  Items.Add('8');
end;

destructor TPLBrushStyleComboBox.Destroy;
begin
  inherited Destroy;
end;

{ TPLPenStyleListBox }

procedure TPLPenStyleListBox.MouseDown(Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  inherited MouseDown(Button, Shift, X, Y);
end;

procedure TPLPenStyleListBox.DrawItem(Index: Integer; ARect: TRect;
  State: TOwnerDrawState);
begin
  canvas.FillRect(arect);

  StrToPen(items[index],fpenstyle);
  canvas.Pen.Style:=fPenStyle;

  canvas.Pen.Color:=clBlack;
  canvas.MoveTo(arect.left,arect.top);
  canvas.LineTo(arect.Right,arect.top);
end;

constructor TPLPenStyleListBox.Create(TheOwner: TComponent);
begin
  inherited Create(TheOwner);
  Style:=lbOwnerDrawVariable;
  Items.Add('0');
  Items.Add('1');
  Items.Add('2');
  Items.Add('3');
  Items.Add('4');
  Items.Add('7');
end;

destructor TPLPenStyleListBox.Destroy;
begin
  inherited Destroy;
end;

{ TPLPenStyleComboBox }

procedure TPLPenStyleComboBox.MouseDown(Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  inherited MouseDown(Button, Shift, X, Y);
end;

procedure TPLPenStyleComboBox.DrawItem(Index: Integer; ARect: TRect;
  State: TOwnerDrawState);
begin
  canvas.FillRect(arect);

  StrToPen(items[index],fpenstyle);
  canvas.Pen.Style:=fPenStyle;

  canvas.Pen.Color:=clBlack;
  canvas.MoveTo(arect.left,arect.top);
  canvas.LineTo(arect.Right,arect.top);
end;

constructor TPLPenStyleComboBox.Create(TheOwner: TComponent);
begin
  inherited Create(TheOwner);

  Style:=csOwnerDrawVariable;
  Items.Add('0');
  Items.Add('1');
  Items.Add('2');
  Items.Add('3');
  Items.Add('4');
  Items.Add('7');

end;

destructor TPLPenStyleComboBox.Destroy;
begin
  inherited Destroy;
end;

procedure TPlColorFehld.SetSelColor(const AValue: TColor);
begin
  if fSelColor=AValue then exit;
  fSelColor:=AValue;
  Paint;
end;

procedure TPlColorFehld.Click(Sender: TObject);
begin
  if oldClick <> NIL then
    oldClick.Pen.color:=clBlack;

  SelectColor:=TShape(Sender).Brush.Color;
  TShape(Sender).Pen.Color:=clRed;
  oldClick:=TShape(Sender);
end;

procedure TPlColorFehld.Paint;
begin
  inherited Paint;
  Canvas.Brush.color:=SelectColor;
  Canvas.FillRect(0,0,Width,FScrollBox.top);
  Canvas.TextOut(0,0,Color2ToString(SelectColor));
end;

{ TPlColorFehld }
procedure TPlColorFehld.Resize;
begin
  inherited Resize;
  if FScrollBox <> NIL then begin
    FScrollBox.Width:=Width; FScrollBox.Height:=Height-FScrollBox.top;
  end;

end;


constructor TPlColorFehld.Create(TheOwner: TComponent);
var
  ColorList:TStringList;
  Shape:TShape;
  i,w,x,zy,y:Integer;
begin
  inherited Create(TheOwner);
  oldClick:=nil;
  FScrollBox:=TScrollBox.Create(self);
  FScrollBox.Parent:=self;
  FScrollBox.left:=0; FScrollBox.top:=15;

  FScrollBox.VertScrollBar.Visible:=True;
  FScrollBox.AutoScroll:=True;

  FScrollBox.Visible:=True;

  ColorList:=TStringList.Create;

  ColorToStringList(ColorList);
  w:=20; x:=0; zy:=0; y:=0;
  for i:=0 to ColorList.Count-1 do begin
    Shape:=TShape.Create(FScrollBox);
    Shape.Parent:=FScrollBox;
    Shape.Brush.color:=String2ToColor(ColorList[i]);

    Shape.left:=x;
    Shape.top:=y;
    Shape.Width:=w;
    Shape.Height:=20;
//    Shape.ShowHint:=True;
//    Shape.Hint:=ColorList[i];
    Shape.OnClick:=@Click;
    x:=x+22;
    if zy+1 >= 10 then begin
      y:=y+22;
      zy:=0;
      x:=0;
    end
    else
      inc(zy);
  end;
end;

destructor TPlColorFehld.Destroy;
begin

end;


{ TPLPaintBox }

procedure TPLPaintBox.Paint;
begin
  Canvas.Rectangle(GetClientRect);

//  Canvas.Frame3d(GetClientRect, 1, bvLowered);
//  InflateRect(GetClientRect, -1, -1);

  inherited Paint;
end; // TPLPaintBox.Paint

constructor TPLPaintBox.Create(TheOwner: TComponent);
begin
  inherited Create(TheOwner);
  SetInitialBounds(0,0,GetControlClassDefaultSize.X,GetControlClassDefaultSize.Y);

end; // TPLPaintBox.Create

destructor TPLPaintBox.Destroy;
begin
  inherited Destroy;
end; // TPLPaintBox.Destroy

initialization
{$I uPlutoCompo.lrs}

end.

