{
  Autor: Michael Springwald

  Erstellt: Samstag der 01.März.2008
  Updates:
  -----------------------------------------------------------------------
01| Sontag, 02.März.2008             | Montag, 03.März.2008             |
  -----------------------------------------------------------------------
02| Dienstag, 04.März.2008           | Freitag, 18.April.2008           |
  -----------------------------------------------------------------------
03|                                  |                                  |
  -----------------------------------------------------------------------
04|                                  |                                  |
  -----------------------------------------------------------------------
05|                                  |                                  |
  -----------------------------------------------------------------------
06|                                  |                                  |
  -----------------------------------------------------------------------
07|                                  |                                  |
  -----------------------------------------------------------------------
08|                                  |                                  |
  -----------------------------------------------------------------------
  Stellt folgende Hauptklassen zur verfügung
  ------------------------------------------
  01 - TPLFileListBox
  02 - TPLExtList
  03 - TPLDirectoryListBox
  04 - TPLFileEdit
  ------------------------------------------
  Das sind die neben Klassen
  ------------------------------------------
  01 - TExtItem - Für TPLExtList enhält nur zwei Variablen
       eine für die erweiterungen die Angezeigt werden soll, eine zweite
  ..........................................
       für die Beschreibung die angzeigt werden. Soll
  02 - TFileItemStyle - Für das Aussehn der Einträge
  ..........................................
  03 - TFileItem - Für 01 und 03 speichert verschiedene Infos über einen
       Eintrag z.b. ob es ein Verzeichnis ist oder nicht
  ..........................................
  ------------------------------------------
  Die TPLDirectoryListBox kann mit der TPLFileListBox verbunden werden.
  Sobald das Verzeichnis sich ändert, passt sich der inhalt von der
  TPLFileListBox an. Die beiden können auch noch mit einem Label
  verbunden werden. Dort wird dann das Gerade Ausgwählte verzeichnis
  angezeigt.
  
  Die TPLExtList kann mit einer TPLFileListBox verbunden werden.
  
  Die TPLFileEdit kann mit einer TPLFileListBox und einer TPLDirectoryListBox
  verbunden werden.
  
  Wird Enter gedrückt, werden die beiden Komponenten Aktuallisiert.
  ------------------------------------------
  Hinweise
  ------------------------------------------
  Wenn Verzeichnise angeben werden bei der TPLFileEdit
  müssen sie immer mit einem \ oder einem / enden. sonst macht
  ExtractFileDir anscheint mist.
  
  Bei der FileMask Eigenschaft TPLFileListBox kann so getrennt werden:
  *.zip*.rar
  Zeigt nur zip und rar Dateien an
  (Groß Klein schreibung beachten)

  

}

unit uplutocompofilelist;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, StdCtrls, Tools_File, Tools, Controls,
  Graphics, LCLType, ComCtrls;

type
// --------------------------------------------------
// - TExtItem                                       -
// --------------------------------------------------
  TExtItem = class
    Value, ext:String;
  end;

// --------------------------------------------------
// - TFileItemStyle                                 -
// --------------------------------------------------
  TFileItemStyle = class
  public
    Brush:TBrush;
    Pen:TPen;
    Font:TFont;
    constructor create;
  end;

// --------------------------------------------------
// TFileItem                                        -
// --------------------------------------------------
  TFileItem = class
  public
    Dir,FileName, cFileName,ldir:String;
    isDir, SubMenu, isLoad:Boolean;
  end;
  
  TPLExtList = class;
  TPLFileEdit = class;
// --------------------------------------------------
// TPLFileListBox
// --------------------------------------------------
  TPLFileListBox = class(TListBox)
  private
    fCurrDir: String;
    fColorMod: Boolean;
    fExtList: TPLExtList;
    fFileAttri: Integer;
    fFileEdit: TPLFileEdit;
    fFileLabel: TLabel;
    fFileMask: String;
    fStyle_Dir: TFileItemStyle;
    fStyle_File: TFileItemStyle;
    fStyle_Sel: TFileItemStyle;
    procedure DrawItem(Index: Integer; ARect: TRect;
                     State: TOwnerDrawState); override;

    procedure KeyUp(var Key: Word;
                      Shift: TShiftState); Override;
    procedure SetFileEdit(const AValue: TPLFileEdit);
    procedure SetFileLabel(const AValue: TLabel);
  protected
    procedure SetCurrDirA(const AValue: String); Virtual;

    procedure SetColorMod(const AValue: Boolean); Virtual;
    procedure SetExtList(const AValue: TPLExtList); Virtual;
    procedure SetFileAttri(const AValue: Integer); Virtual;
    procedure SetFileMask(const AValue: String); Virtual;
    procedure DblClick; override;
    procedure Click; override;

  public
    dirs, files:TStringList;
    isAddDir, isAddFile:Boolean;

    constructor Create(TheOwner: TComponent); override;
    destructor Destroy; override;
    
    procedure ReadDir;
  published
    property CurrDir:String read fCurrDir write SetCurrDirA;
    property ColorMod:Boolean read fColorMod write SetColorMod;

    property Style_Dir:TFileItemStyle read fStyle_Dir write fStyle_Dir;
    property Style_File:TFileItemStyle read fStyle_File write fStyle_File;
    property Style_Sel:TFileItemStyle read fStyle_Sel write fStyle_Sel;
    property FileAttri:Integer read fFileAttri write SetFileAttri;
    property FileMask:String read fFileMask write SetFileMask;

    property ExtList:TPLExtList read fExtList write SetExtList;
    property FileEdit:TPLFileEdit read fFileEdit write SetFileEdit;
    property FileLabel:TLabel read fFileLabel write SetFileLabel;

  end; // TPLFileListBox
  

// --------------------------------------------------
// - TPLExtList                                     -
// --------------------------------------------------
  TPLExtList = class(TComboBox)
    fFileListBox: TPLFileListBox;
  private
    procedure Sel(sender:TObject);
    procedure SetFileListBox(const AValue: TPLFileListBox);

  protected

  public
    constructor Create(TheOwner: TComponent); override;
    destructor Destroy; override;
    
    procedure AddExt(const aExt, aValue:String);
  published
    property FileListBox:TPLFileListBox read fFileListBox write SetFileListBox;

  end; // TPLExtList
  
// --------------------------------------------------
// - TPLDirectoryListBox                            -
// --------------------------------------------------
  TPLDirectoryListBox = class(TPLFileListBox)
    fFileListBox: TPLFileListBox;
    procedure SetFileListBox(const AValue: TPLFileListBox);
  private

  protected
    procedure SetCurrDirA(const AValue: String); override;
  public
    constructor Create(TheOwner: TComponent); override;
    destructor Destroy; override;
  published
    property FileListBox:TPLFileListBox read fFileListBox write SetFileListBox;

  end; // TPLDirectoryListBox

// --------------------------------------------------
// - TPLFileEdit                                    -
// --------------------------------------------------
  TPLFileEdit = class(TEdit)
    fDirList: TPLDirectoryListBox;
    fFileList: TPLFileListBox;
    procedure SetDirList(const AValue: TPLDirectoryListBox);
    procedure SetFileList(const AValue: TPLFileListBox);
  private

  protected
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;

  public
    constructor Create(TheOwner: TComponent); override;
    destructor Destroy; override;
    
  published
    property FileList:TPLFileListBox read fFileList write SetFileList;
    property DirectoryList:TPLDirectoryListBox read fDirList write SetDirList;
  end; // TPLFileEdit

// --------------------------------------------------
// - TPLFileTree                                    -
// --------------------------------------------------

  { TPLFileTree }
  TPLFileTree = class(TTreeView)
  private
    fCurrDir: string;
    fFileMask: String;
    dirs, files:TStringList;
    procedure SetFileMask(const AValue: String);
    procedure SetCurrDir(const AValue: string);
  protected
     procedure Expand(Node: TTreeNode); override;

  public
    isAddDir, isAddFile:Boolean;
    LastAddItem:TTreeNode;

    constructor Create(TheOwner: TComponent); override;
    destructor Destroy; override;
    
    function GetTreeNode(const aNode:TTreeNode; const aStr:String):TTreeNode;
    
    procedure ReadDir(const aDir:string = '');
    function ReadToTree(const aDir:String = '/'; const at:String = ''; anode:TTreeNode=nil; var tNode:TTreeNode = nil):TTreeNode;
    
    procedure OpenDir;
  published
    property CurrDir:string read fCurrDir write SetCurrDir;
    property FileMask:String read fFileMask write SetFileMask;
  end; // TPLFileTree

 procedure register;

implementation

procedure register;
begin
   RegisterComponents('Pluto',[TPLFileListBox]);
   RegisterComponents('Pluto',[TPLExtList]);
   RegisterComponents('Pluto',[TPLDirectoryListBox]);
   RegisterComponents('Pluto',[TPLFileEdit]);
   RegisterComponents('Pluto',[TPLFileTree]);

end; // procedure register

// --------------------------------------------------
// TPLFileListBox                                   -
// --------------------------------------------------
procedure TPLFileListBox.SetCurrDirA(const AValue: String);
var
  ch:Boolean;
  s:String;
begin
  if AValue = '' then exit;
  if AValue[Length(AValue)] <> DirectorySeparator then
    s:=DirectorySeparator
  else
    s:='';
  
  ch:=fCurrDir <> AValue;
  fCurrDir:=AValue+s;
  if ch then ReadDir
end; // TPLFileListBox.SetCurrDir

procedure TPLFileListBox.SetExtList(const AValue: TPLExtList);
begin
  if fExtList=AValue then exit;
  fExtList:=AValue;
end; // TPLFileListBox.SetExtList

procedure TPLFileListBox.SetFileAttri(const AValue: Integer);
begin
  if fFileAttri=AValue then exit;
  fFileAttri:=AValue;
  read;
end; // TPLFileListBox.SetFileAttri

procedure TPLFileListBox.SetFileMask(const AValue: String);
begin
  if fFileMask=AValue then exit;
  fFileMask:=LowerCase(AValue);
  ReadDir;
end; // TPLFileListBox.SetFileMask

procedure TPLFileListBox.SetColorMod(const AValue: Boolean);
begin
  if fColorMod=AValue then exit;
  fColorMod:=AValue;
end; // TPLFileListBox.SetColorMod

procedure TPLFileListBox.DblClick;
var
  af:TFileItem;
begin
  inherited DblClick;
  if ItemIndex > -1 then begin
    af:=(items.Objects[ItemIndex] as TFileItem);
    if af.isDir then begin
      if (af.Dir = '.') or (af.dir ='..') then
        CurrDir:=GetPrvDir1(CurrDir)
      else
        CurrDir:=CurrDir + af.Dir;
//      writeln(CurrDir);
    end;
  end;
end; // TPLFileListBox.Klick(Sender: TObject)

procedure TPLFileListBox.Click;
begin
  inherited Click;
  if (assigned(FileEdit)) and (ItemIndex > -1) then begin
    if not TFileItem(items.Objects[ItemIndex]).isDir then
      FileEdit.Text:=Items[ItemIndex]
    else begin
      if assigned(FileLabel) then begin
        FileLabel.Caption:=Items[ItemIndex];
      end;
    end;
  end
  else begin
    if (assigned(FileLabel)) and (Itemindex > -1) then begin
      if TFileItem(items.Objects[ItemIndex]).isDir then
      FileLabel.Caption:=CurrDir + TFileItem(items.Objects[ItemIndex]).Dir + DirectorySeparator;
    end;
  end;
end; // TPLFileListBox.Click

procedure TPLFileListBox.DrawItem(Index: Integer;
  ARect: TRect; State: TOwnerDrawState);
var
  af:TFileItem;
begin
  inherited DrawItem(index, Arect, State);
  af:=(items.Objects[index] as TFileItem);
  
  if ColorMod then begin

    if af.isDir then begin
      Canvas.Font.Assign(Style_Dir.Font);
      Canvas.Brush.Assign(Style_Dir.Brush);
      Canvas.Pen.Assign(Style_Dir.Pen);
    end
    else begin
      Canvas.Font.Assign(Style_File.Font);
      Canvas.Brush.Assign(Style_File.Brush);
      Canvas.Pen.Assign(Style_File.Pen);
    end;

    if odSelected in State then begin
      Canvas.Font.Assign(Style_Sel.Font);
      Canvas.Brush.Assign(Style_Sel.Brush);
      Canvas.Pen.Assign(Style_Sel.Pen);
    end;
  end;

  if not ColorMod then
    canvas.FillRect(ARect)
  else
    canvas.Rectangle(ARect);
  Canvas.TextOut(ARect.Left+2,ARect.Top+2,af.cFileName);
end; // TPLFileListBox.DrawItem

procedure TPLFileListBox.KeyUp(var Key: Word; Shift: TShiftState);
var
  af:TFileItem;
begin
  inherited KeyUP(key, shift);
  if (key = VK_RETURN) or (key = VK_SPACE) then begin
    if ItemIndex > -1 then begin
      af:=(items.Objects[ItemIndex] as TFileItem);
//      writeln('ItemIndex:',ItemIndex);
      if af.isDir then begin
        if (af.Dir = '.') or (af.dir ='..') then
          CurrDir:=GetPrvDir1(CurrDir)
        else
          CurrDir:=CurrDir + af.Dir;
        ItemIndex:=0;
      end;
    end;

  end;
end; // TPLFileListBox.KeyDown

procedure TPLFileListBox.SetFileEdit(const AValue: TPLFileEdit);
begin
  if fFileEdit=AValue then exit;
  fFileEdit:=AValue;
end; // TPLFileListBox.SetFileEdit

procedure TPLFileListBox.SetFileLabel(const AValue: TLabel);
begin
  if fFileLabel=AValue then exit;
  fFileLabel:=AValue;
end; // TPLFileListBox.SetFileLabel

constructor TPLFileListBox.Create(TheOwner: TComponent);
begin
  inherited Create(TheOwner);
  isAddDir:=True; isAddFile:=True;
  Style_Dir:=TFileItemStyle.Create;
  Style_Dir.Font.Color:=clBlack;
  Style_Dir.Brush.Color:=clWhite;
  Style_Dir.Pen.Style:=psClear;

  Style_File:=TFileItemStyle.Create;
  Style_File.Font.Color:=clBlack;
  Style_File.Brush.Color:=clWhite;
  Style_File.Pen.Style:=psClear;
  
  Style_Sel:=TFileItemStyle.Create;
  Style_Sel.Font.Color:=clBlack;
  Style_Sel.Brush.Color:=clBlue;

  dirs:=TStringList.Create;
  files:=TStringList.Create;
  Style:=lbOwnerDrawVariable;
  ColorMod:=True;
  ExtList:=nil; fFileLabel:=nil;

  FileAttri:=faAnyFile and faDirectory;
end; // TPLFileListBox.Create

destructor TPLFileListBox.Destroy;
begin
  inherited Destroy;
end; // TPLFileListBox.Destroy

procedure TPLFileListBox.ReadDir;
var
  Info:TSearchRec;
  FileItem:TFileItem;
  d, f, ok:Boolean;
  ext:string;
begin
  items.clear; dirs.Clear; files.clear;
  if FindFirst (CurrDir+'*',FileAttri,Info)=0 then begin
    repeat
      with Info do begin
        if (Attr and faDirectory) = faDirectory  then begin
          if isAddDir then begin
            FileItem:=TFileItem.Create;
            FileItem.Dir:=Info.Name;
            FileItem.isDir:=True;
            FileItem.cFileName:='['+Info.Name+']';
            dirs.AddObject(FileItem.cFileName,FileItem);
          end;
        end
        else begin

          if FileMask <> '' then begin
            ext:='*'+LowerCase(ExtractFileExt(info.Name));
            if (pos('.*',FileMask) = 0) and (FileMask <> '*') then begin
              if pos(ext, FileMask) > 0 then ok:=True else ok:=False;
            end
            else
              ok:=True;
          end
          else
            ok:=True;
          
          if (ok) and (isAddFile) then begin
            FileItem:=TFileItem.Create;
            FileItem.Dir:='';
            FileItem.isDir:=False;
            FileItem.cFileName:=Info.Name;
            files.AddObject(FileItem.cFileName,FileItem);
          end;
        end;
      end;

      until FindNext(info)<>0;
    end;
  FindClose(Info);
  
  if FileMask <> '' then begin
    ok:=False;

    if FileMask = '*' then begin
      ok:=False;
    end; // *

    // Nur Dateien
    if FileMask = '.*'  then begin
      if dirs.count >=1 then
        Items.AddObject(dirs.Strings[0],dirs.Objects[0]);
      if dirs.count >= 2 then
        Items.AddObject(dirs.Strings[1],dirs.Objects[1]);
          
      Items.AddStrings(files);
      ok:=True;
    end; // .*

    // Nur Verzeichnisse
    if FileMask = '*.' then begin
      Items.AddStrings(dirs);
      ok:=True;
    end; // *.
      
    if not ok then begin
      Items.AddStrings(dirs);
      Items.AddStrings(files);
    end;
  end
  else begin
    Items.AddStrings(dirs);
    Items.AddStrings(files);
  end;

end; // TPLFileListBox.ReadDir

// --------------------------------------------------
// - TFileItemStyle                                 -
// --------------------------------------------------
constructor TFileItemStyle.create;
begin
  Pen:=TPen.Create;
  Brush:=TBrush.Create;
  Font:=TFont.Create;
end;

// --------------------------------------------------
// - TPLExtList                                     -
// --------------------------------------------------
procedure TPLExtList.Sel(sender: TObject);
begin
  if (ItemIndex > -1) and (FileListBox <> nil ) then begin
    FileListBox.FileMask:=TExtItem(items.Objects[itemindex]).ext;
    FileListBox.ReadDir;
  end;
end; // TPLExtList.Sel

procedure TPLExtList.SetFileListBox(const AValue: TPLFileListBox);
begin
  if fFileListBox=AValue then exit;
  fFileListBox:=AValue;
end; // TPLExtList.SetFileListBox

constructor TPLExtList.Create(TheOwner: TComponent);
begin
  inherited Create(TheOwner);
  FileListBox:=nil;
  OnSelect:=@Sel;
end; // TPLExtList.Create

destructor TPLExtList.Destroy;
begin
  inherited Destroy;
end; // TPLExtList.Destroy

procedure TPLExtList.AddExt(const aExt, aValue: String);
var
  ExtItem:TExtItem;
begin
  ExtItem:=TExtItem.Create;
  ExtItem.ext:=aExt;
  ExtItem.Value:=aValue;

  items.AddObject(ExtItem.Value, ExtItem);
end; // TPLExtList.AddExt

// --------------------------------------------------
// TplDirectoryListBox                              -
// --------------------------------------------------
procedure TplDirectoryListBox.SetFileListBox(const AValue: TPLFileListBox);
begin
  if fFileListBox=AValue then exit;
  fFileListBox:=AValue;
  if assigned(fFileListBox) then begin
    fFileListBox.isAddDir:=False;
    fFileListBox.ReadDir;
  end;
end; // TplDirectoryListBox.SetFileListBox

procedure TplDirectoryListBox.SetCurrDirA(const AValue: String);
begin
  inherited SetCurrDirA(AValue);
  if FileListBox <> NIL then begin
    FileListBox.CurrDir:=CurrDir;
  end;
end; // TplDirectoryListBox.SetCurrDirA

constructor TplDirectoryListBox.Create(TheOwner: TComponent);
begin
  inherited Create(TheOwner);
  isAddFile:=False;

  Style_Dir.Font.color:=clBlack;

  Style_File.Font.Color:=clBlue;

  Style_Sel.Font.Color:=clBlue;
  Style_Sel.Brush.Color:=clRed;
  Style_Sel.Pen.Color:=clWhite;

end; // TplDirectoryListBox.Create

destructor TplDirectoryListBox.Destroy;
begin
  inherited Destroy;
end; // TplDirectoryListBox.Destroy

procedure TPLFileEdit.SetDirList(const AValue: TPLDirectoryListBox);
begin
  if fDirList=AValue then exit;
  fDirList:=AValue;
end; // TPLFileEdit.SetDirList

procedure TPLFileEdit.SetFileList(const AValue: TPLFileListBox);
begin
  if fFileList=AValue then exit;
  fFileList:=AValue;
end; // TPLFileEdit.SetFileList

procedure TPLFileEdit.KeyDown(var Key: Word; Shift: TShiftState);
var
  aDir, aFileName, aMask:String;
begin
  inherited KeyDown(Key, Shift);
  
  if KEY = VK_RETURN then begin
    aDir:=ExtractFilePath(Text); aFileName:=ExtractFileDir(Text);
    aMask:=''; if Pos('*',text) >0 then begin
      aMask:=text;
    end;

    writeln(aDir,'|',aFileName,'|',aMask);
    if Assigned(DirectoryList) then begin
      if aMask = '' then begin
        DirectoryList.CurrDir:=aDir;
      end
      else begin
        if Assigned(FileList) then begin
          FileList.FileMask:=aMask;
        end;
      end
    end // DirectoryList
    else begin
      if Assigned(FileList) then begin
        FileList.FileMask:=aMask;
        if aMask = '' then
          FileList.CurrDir:=aDir
        else
          FileList.FileMask:=aMask;
      end; // FileList
    end;
    
  end;
end; // TPLFileEdit.KeyDown

// --------------------------------------------------
// - TPLFileEdit                                    -
// --------------------------------------------------
constructor TPLFileEdit.Create(TheOwner: TComponent);
begin
  inherited Create(TheOwner); fDirList:=nil; fFileList:=nil;
end; // TPLFileEdit.Create

destructor TPLFileEdit.Destroy;
begin
  inherited Destroy;
end; // TPLFileEdit.Destroy

// --------------------------------------------------
// - TPLFileTree                                    -
// --------------------------------------------------
procedure TPLFileTree.SetCurrDir(const AValue: string);
begin
  if fCurrDir=AValue then exit;
  fCurrDir:=AValue;
  //OpenDir;
//  readdir;
end; // TPLFileTree.SetCurrDir

procedure TPLFileTree.Expand(Node: TTreeNode);
var
  fa:TFileItem;
  f:TTreeNode;
begin
  inherited Expand(Node);f:=nil;

 if (assigned(Node.Data)) and (node.Count = 0) then begin
    fa:=TFileItem(Node.Data);
    if not fa.isLoad then begin
      fa.isLoad:=True;

      ReadToTree(fa.ldir + '/','',node,f);
    end;
  end
  else
    writeln('TEST');
end; // TPLFileTree.Expand

procedure TPLFileTree.SetFileMask(const AValue: String);
begin
  if fFileMask=AValue then exit;
  fFileMask:=AValue;
//  readdir;
end; // TPLFileTree.SetFileMask

constructor TPLFileTree.Create(TheOwner: TComponent);
begin
  inherited Create(TheOwner);
  dirs:=TStringList.Create; files:=TStringList.Create;
  isAddDir:=True;
  isAddFile:=True;

end; // TPLFileTree.Create

destructor TPLFileTree.Destroy;
begin
  inherited Destroy;
end; // TPLFileTree.Destroy

function TPLFileTree.GetTreeNode(const aNode: TTreeNode;
  const aStr: String): TTreeNode;
var
  i:Integer;
  tmp:TTreeNode;
begin
  tmp:=nil;
  if assigned(aNode) then begin
    for i:=0 to aNode.Count-1 do begin
      if anode.items[i].Text = aStr then begin
        tmp:=anode.items[i];
        break;
      end;
    end; // for i
  end;
  result:=tmp;
end; // TPLFileTree.GetTreeNode

procedure TPLFileTree.ReadDir(const aDir:string = '');
var
  Info:TSearchRec;
  FileItem:TFileItem;
  d, f, ok:Boolean;
  ext,h:string;
begin
  dirs.Clear; files.clear;
  if aDir <> '' then h:=aDir else h:=CurrDir;
  
  if FindFirst (h+'*',faAnyFile and faDirectory,Info)=0 then begin
    repeat
      if (info.Name <> '.') and (info.Name <> '..') then begin
        with Info do begin
          if (Attr and faDirectory) = faDirectory  then begin
            if isAddDir then begin
              FileItem:=TFileItem.Create;
              FileItem.Dir:=Info.Name;
              FileItem.isDir:=True;
              FileItem.cFileName:=Info.Name;
              dirs.AddObject(FileItem.cFileName,FileItem);
            end;
          end
          else begin
            if FileMask <> '' then begin
              ext:='*'+LowerCase(ExtractFileExt(info.Name));
              if (pos('.*',FileMask) = 0) and (FileMask <> '*') then begin
                if pos(ext, FileMask) > 0 then ok:=True else ok:=False;
              end
              else
                ok:=True;
            end
            else
              ok:=True;

            if (ok) and (isAddFile) then begin
              FileItem:=TFileItem.Create;
              FileItem.Dir:='';
              FileItem.isDir:=False;
              FileItem.cFileName:=Info.Name;
              files.AddObject(FileItem.cFileName,FileItem);
            end;
          end;
        end;
      end; //
      until FindNext(info)<>0;
    end;
  FindClose(Info);
  if Selected = nil then begin
  end;

 { if FileMask <> '' then begin
    ok:=False;

    if FileMask = '*' then begin
      ok:=False;
    end; // *

    // Nur Dateien
    if FileMask = '.*'  then begin
      if dirs.count >=1 then
        Items.AddObject(dirs.Strings[0],dirs.Objects[0]);
      if dirs.count >= 2 then
        Items.AddObject(dirs.Strings[1],dirs.Objects[1]);

      Items.AddStrings(files);
      ok:=True;
    end; // .*

    // Nur Verzeichnisse
    if FileMask = '*.' then begin
      Items.AddStrings(dirs);
      ok:=True;
    end; // *.

    if not ok then begin
      Items.AddStrings(dirs);
      Items.AddStrings(files);
    end;
  end
  else begin}
//    Items.AddStrings(dirs);
//    Items.AddStrings(files);
  //end;

end; // TPLFileTree.ReadDir

function TPLFileTree.ReadToTree(const aDir: String = '/'; const at:String = '';anode:TTreeNode=nil; var tNode:TTreeNode = nil):TTreeNode;
var
  a,h,l,ok:TTreeNode;
  i,k:Integer;
  dir,t:String;
begin
  ReadDir(aDir);
  if anode = NIL then begin
    a:=Items.Add(anode,GetPrvDir(aDir));
    a.Data:=TFileItem.Create;
    TFileItem(a.Data).ldir:=aDir;
    result:=a;
 end
  else begin
    a:=aNode; ok:=a;
    a.Data:=TFileItem.Create;
    TFileItem(a.Data).ldir:=aDir;
    result:=a;
  end;

  for i:=0 to dirs.count-1 do begin
    dir:=dirs[i];
    h:=Items.AddChild(a,dir);
    h.HasChildren:=GetAnderDir(aDir + dir ,'*',faAnyFile and faDirectory);
    h.Data:=TFileItem(dirs.Objects[i]);
    TFileItem(h.data).SubMenu:=h.HasChildren;
    TFileItem(h.data).isLoad:=False;
    TFileItem(h.data).ldir:=aDir + dirs[i];
    if dir = at then begin
      ok:=h;
    end;
  end; // for i:=0

  for k:=0 to files.count-1 do begin
    l:=Items.AddChild(a,files[k]);
    l.HasChildren:=False;
    l.Data:=TFileItem(files.Objects[k]);

    TFileItem(l.data).SubMenu:=l.HasChildren;
    TFileItem(l.data).isLoad:=False;
    TFileItem(l.data).ldir:=aDir + files[k];
  end; // for i:=0

  tnode:=ok;
end; //  TPLFileTree.ReadToTree

procedure TPLFileTree.OpenDir;
var
  Tmpdir,s,l:String;
  i,c:Integer;
  h,k:TTreeNode;
begin
  Tmpdir:=''; k:=nil; c:=NumToken(CurrDir,DirectorySeparator);
  h:=nil;
  for i:=1 to c-1 do begin
    s:=GetToken(CurrDir,DirectorySeparator,i);
    if i+1 <=c then
      l:=GetToken(CurrDir,DirectorySeparator,i+1)
    else
      l:='';
    Tmpdir:=Tmpdir+s +'/';
    if TmpDir <> '' then begin
   //   writeln(tmpdir);
      k:=ReadToTree(Tmpdir,l,h,h);
      TFileItem(k.Data).isLoad:=True;
      k.Expanded:=True;
    end;

  end; // for i
  LastAddItem:=k;
end; // TPLFileTree.OpenDir

end.

